// WinAPI.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "WinAPI.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINAPI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINAPI);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WINAPI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WINAPI;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      100,100, 320,250, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void DrawPenType(HDC hdc, LPCTSTR lpText, int nType, int yPos)
{
	HPEN hPen, hpOld;
	MoveToEx(hdc, 10, yPos, NULL);
	hPen = CreatePen(nType, 1, 0x00);
	hpOld = (HPEN)SelectObject(hdc, hPen);
	LineTo(hdc, 100, yPos); 
	SIZE size;
	GetTextExtentPoint32(hdc, lpText, strlen(lpText), &size);
	TextOut(hdc, 110, yPos-(size.cy/2),
		lpText, lstrlen(lpText));
}

void DrawPolyLine(HDC hdc)
{
	HPEN hPen, hpOld;
	POINT MyPoints[6] = {50,2, 2,98, 98,33, 2,33, 98,98, 50,2};
	hPen = CreatePen(PS_SOLID, 4, 0x00FF0000);
	hpOld = (HPEN)SelectObject(hdc, hPen);
	Polyline(hdc, MyPoints, 6);
	// Ped zruenm objektu ho vyjmeme z DC
	SelectObject(hdc, hpOld);
	DeleteObject(hPen);	
}

void DrawAngles(HDC hdc)
{
	HPEN hPen1, hPen2, hpOld;
	hPen1 = CreatePen(PS_SOLID, 4, 0x0000FF00);
	hPen2 = CreatePen(PS_DASHDOT, 1, 0x000000FF);
	hpOld = (HPEN)SelectObject(hdc, hPen2);
	MoveToEx(hdc, 250, 50, NULL);
	AngleArc(hdc, 200, 50, 50, 0, 90);
	SelectObject(hdc, hPen1);
	AngleArc(hdc, 200, 50, 50, 90, 90);
	SelectObject(hdc, hPen2);
	AngleArc(hdc, 200, 50, 50, 180, 90);
	SelectObject(hdc, hPen1);
	AngleArc(hdc, 200, 50, 50, 270, 90);
	SelectObject(hdc, hpOld);
	DeleteObject(hPen1);
	DeleteObject(hPen2);
}

void OnPaint(HDC hdc)
{
	DrawPolyLine(hdc);
	DrawAngles(hdc);
	int yPos = 120;
	DrawPenType(hdc, "PS_DASH", PS_DASH, yPos);
	yPos += 20;
	DrawPenType(hdc, "PS_DOT", PS_DOT, yPos);
	yPos += 20;
	DrawPenType(hdc, "PS_DASHDOT", PS_DASHDOT, yPos);
	yPos += 20;
	DrawPenType(hdc, "PS_DASHDOTDOT", PS_DASHDOTDOT, yPos);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
